/* SimpleCustomSkins.sp

Description: A simple plugin to apply custom player skins.

*/

#include <sourcemod>
#include <sdktools>

#define PLUGIN_VERSION "1.4"
#define MAX_FILE_LEN 256

public Plugin:myinfo = 
{
	name = "simplecustomskins",
	author = "Meng",
	version = "PLUGIN_VERSION",
	description = "Simple Skin Changer",
	url = ""
};

new Handle:g_enabled = INVALID_HANDLE;
new Handle:g_adminonly = INVALID_HANDLE;
new Handle:g_skinbots = INVALID_HANDLE;
new Handle:g_customctskin = INVALID_HANDLE;
new Handle:g_customtskin = INVALID_HANDLE;
new String:g_ctskin[MAX_FILE_LEN];
new String:g_tskin[MAX_FILE_LEN];

public OnPluginStart()
{
	CreateConVar("simplecustomskins_version", PLUGIN_VERSION, "simplecustomskins Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	g_enabled = CreateConVar("sm_simple_skins", "1", "Set to 1 to enable custom skins");
	g_adminonly = CreateConVar("sm_ss_adminonly", "1", "Set to 1 to apply skins to admins only");
	g_skinbots = CreateConVar("sm_ss_skinbots", "0", "Set to 1 to skin bots as well");
	g_customctskin = CreateConVar("sm_ss_ctskin", "models/player/ct_urban.mdl", "ct model");
	g_customtskin = CreateConVar("sm_ss_tskin", "models/player/t_phoenix.mdl", "t model");

	AutoExecConfig(true, "simple_custom_skins");

	HookEvent("player_spawn", EventPlayerSpawn);
}

public OnMapStart()
{
	decl String:buffer[MAX_FILE_LEN];
	new String:file[256]
	BuildPath(Path_SM, file, 255, "configs/simple_skins_downloads.ini")
	new Handle:fileh = OpenFile(file, "r")
	while (ReadFileLine(fileh, buffer, sizeof(buffer)))
	{
		new len = strlen(buffer)
		if (buffer[len-1] == '\n')
			buffer[--len] = '\0'
		if (buffer[len-1] == '\r')
			buffer[--len] = '\0'

		if (FileExists(buffer))
			AddFileToDownloadsTable(buffer)

		if (IsEndOfFile(fileh))
			break
	}
}

public OnConfigsExecuted()
{
	decl String:buffer[MAX_FILE_LEN];
	GetConVarString(g_customctskin, g_ctskin, sizeof(g_ctskin));
	Format(buffer, MAX_FILE_LEN, "%s", g_ctskin);
	PrecacheModel(g_ctskin, true);

	GetConVarString(g_customtskin, g_tskin, sizeof(g_tskin));
	Format(buffer, MAX_FILE_LEN, "%s", g_tskin);
	PrecacheModel(g_tskin, true);
}

SetModel(client)
{
	new team = GetClientTeam(client);
	if (team == 3)
	{
		SetEntityModel(client,g_ctskin);
	}
	else if (team == 2)
	{
		SetEntityModel(client,g_tskin);
	}
}

public Action:EventPlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast)
{       
	if (GetConVarInt(g_enabled))
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		if (GetConVarInt(g_skinbots) && IsFakeClient(client))
		{
			SetModel(client);
		}
		if (GetConVarInt(g_adminonly) && GetUserFlagBits(client) & ADMFLAG_CUSTOM5)
		{
			SetModel(client);
		}
		else if (!GetConVarInt(g_adminonly) && !IsFakeClient(client))
		{
			SetModel(client);
		}
	}
}